Microsoft Service Bus Connector Demo - AMQP
====================================
Mule Studio demo for Microsoft Service Bus connector. This sample contains two scenarios: one for the management API that allows to create Topics,
Subscriptions and Rules, and the one for the AMQP part of the connector that allows to send and receive messages based on different filters.

AMQP sample
-----------

This sample illustrates how to consume messages from Service Bus topics and queues configured with different filters using an AMQP connection.

Prerequisites
---------------

* A running instance of Azure Service Bus or Windows Service Bus with a Namespace already created.
* A topic created with three subscriptions.
* A subscription HighPriority with the default filter ($Default) set to "priority = HIGH".
* A subscription MediumPriority with the default filter ($Defult) set to "priority = MEDIUM".
* A subscription LowPriority with the default filter ($Default) set to "priority = LOW".
* A subscription LargeMessages with no default filter
* A destination queue to send messages to
* A storage account with blob storage enabled. If no blob container is created, a default one will be created

The topic, subscriptions and rules can be created with the Management API Demo.

How to Run Sample
-----------------

1.	Import the project folder azure-service-bus-amqp-demo in Studio.
2.	Update the Service Bus connection parameters in /src/main/app/mule-app.properties. Note: By default, Azure configuration is used in the flows. If running against windows service bus, change the Connector Configuration of all Microsoft Service Bus Connectors to Microsoft_Service_Bus__Windows_Service_Bus
3.	Set the topic path property in /src/main/app/mule-app.properties
4.	From the 'Global Elements' tab, open the Microsoft_Service_Bus__Azure_Service_Bus connection.
5.	Click on 'Test Connection' to make sure the connection works correctly.
6.	From the 'Global Elements' tab, open the Microsoft_Service_Bus__Azure_Service_Bus_for_large_messages connection.
7.	Click on 'Test Connection' to make sure the connection works correctly.
8.	Run the application.

About the Sample
----------------

This sample consists of a flow for sending messages to the configured topic and three other flows that are receiving messages for each of the subscriptions (HighPriority, MediumPriority and LowPriority).

The flow for sending messages exposes an Http endpoint, which can be hit with the following URL: http://localhost:8081/pushMessage?amqp.priority={priority}

or open http://localhost:8081/ in the browser and use the form to send messages.

By default, only the HighPriority flow is started. So, if a message is send with the priority HIGH, it will be received and logged in the console, otherwise it will not be received.

To receive messages with MEDIUM or LOW priority, click on the flow and change its initial state to "started".

Messages with priority different than HIGH, MEDIUM or LOW will be received in the LargeMessagesSubscription(it does not matter how they were sent).

To send large messages(more than 256KB) through the queue send a POST request to http://localhost:8081/large-message/queue/ with the needed body. The message will be received in the ReceiveLargeMessagesFromQueue flow and then displayed in the console.